diff -Nacr stunnel-3.8.orig/Makefile stunnel-3.8/Makefile
*** stunnel-3.8.orig/Makefile	Wed Dec 31 19:00:00 1969
--- stunnel-3.8/Makefile	Fri Jul 21 13:53:47 2000
***************
*** 0 ****
--- 1,110 ----
+ # Generated automatically from Makefile.in by configure.
+ #####################################################
+ # Makefile for stunnel by Michal Trojnara 1998-2000 #
+ #####################################################
+ 
+ prefix=/usr/local
+ exec_prefix=${prefix}
+ sbindir=${exec_prefix}/sbin
+ libdir=${exec_prefix}/lib
+ man8dir=${prefix}/man/man8
+ piddir=${prefix}/var/klpstunnel
+ ssldir=/usr/local/ssl
+ certdir=$(ssldir)/certs
+ 
+ VERSION=stunnel-3.8
+ RANDOM_OPT=
+ CC=gcc
+ INSTALL=./install-sh -c
+ CFLAGS=-g -O2 -Wall -DNO_IDEA -I/usr/local/ssl/include -I/usr/local/krb5/include  -DVERSION=\"3.8\" -DHAVE_OPENSSL=1 -Dssldir=\"/usr/local/ssl\" -DHAVE_KRB5=1 -DHOST=\"sparc-sun-solaris2.7\" -DHAVE_LIBNSL=1 -DHAVE_LIBSOCKET=1 -DHAVE_LIBPTHREAD=1 -DHAVE_LIBWRAP=1 -DHAVE_DEV_PTMX=1 -DHAVE_UNISTD_H=1 -DHAVE_SYS_SELECT_H=1 -DHAVE_TCPD_H=1 -DHAVE_PTHREAD_H=1 -DHAVE_STROPTS_H=1 -DHAVE_GETOPT=1 -DHAVE_SNPRINTF=1 -DHAVE_VSNPRINTF=1  -Dcertdir=\"$(certdir)\" -Dlibdir=\"$(libdir)\" -Dpiddir=\"$(piddir)\"
+ LIBS=-lwrap -lpthread -lsocket -lnsl  -L/usr/local/ssl/lib -lssl -lcrypto -L/usr/local/krb5/lib -lgssapi_krb5 -lkrb5 -lcom_err /usr/local/krb5/lib/libcrypto.a -lresolv
+ OBJS=stunnel.o ssl.o protocol.o sthreads.o pty.o log.o  truerand.o
+ DESTFILES=$(sbindir)/klpstunnel $(libdir)/stunnel.so $(man8dir)/stunnel.8 $(certdir)/klpstunnel.pem
+ 
+ # standard external rules
+ 
+ all: klpstunnel stunnel.so klpstunnel.pem
+ 
+ install: all installdirs $(DESTFILES)
+ 
+ uninstall:
+ 	rm -f $(DESTFILES)
+ 
+ install-strip:
+ 	$(MAKE) INSTALL='$(INSTALL) -s' install
+ 
+ clean:
+ 	rm -f klpstunnel stunnel.so $(OBJS) core config.log
+ 
+ distclean: clean
+ 	rm -f stunnel.8 config.cache config.status Makefile
+ 
+ mostlyclean: distclean
+ 
+ maintainer-clean: distclean
+ 
+ dist: distclean ../dist/$(VERSION).exe
+ 	cp -rp . ../dist/$(VERSION)
+ 	tar -cf - -C ../dist $(VERSION) | gzip > ../dist/$(VERSION).tar.gz
+ 	rm -rf ../dist/$(VERSION)
+ 	gpg --yes --armor --detach-sign ../dist/$(VERSION).tar.gz
+ 
+ installdirs: mkinstalldirs
+ 	./mkinstalldirs $(sbindir) $(libdir) $(man8dir) $(certdir) $(piddir)
+ 	chmod a=rwx,+t $(piddir)
+ 
+ # non-standard external rules
+ 
+ stunnel.html: man2html.pl stunnel.8
+ 	./man2html.pl < stunnel.8 > stunnel.html
+ 
+ cert:
+ 	rm -f klpstunnel.pem
+ 	$(MAKE) klpstunnel.pem
+ 
+ # internal rules
+ 
+ klpstunnel: $(OBJS)
+ 	$(CC) $(LDFLAGS) -o klpstunnel $(OBJS) $(LIBS)
+ 
+ stunnel.so: Makefile env.c
+ 	$(CC) -fPIC -shared $(LDFLAGS) -o stunnel.so env.c $(LIBS) || \
+ 	touch stunnel.so
+ 	@test -s klpstunnel.pem || echo
+ 	@test -s klpstunnel.pem || echo "You can ignore this error"
+ 	@test -s klpstunnel.pem || echo "Shared library won't work on your system"
+ 	@test -s klpstunnel.pem || echo
+ 
+ Makefile: configure Makefile.in
+ 	./configure
+ 	$(MAKE) clean
+ 
+ configure: configure.in
+ 	autoconf
+ 
+ $(OBJS): Makefile common.h
+ 
+ klpstunnel.pem: stunnel.cnf
+ 	$(ssldir)/bin/openssl req -new -x509 -days 365 -nodes \
+ 		-config stunnel.cnf -out klpstunnel.pem -keyout klpstunnel.pem
+ 	$(ssldir)/bin/openssl gendh $(RANDOM_OPT) 512 >> klpstunnel.pem
+ 	$(ssldir)/bin/openssl x509 -subject -dates -fingerprint -noout \
+ 		-in klpstunnel.pem
+ 
+ $(sbindir)/klpstunnel: klpstunnel
+ 	$(INSTALL) -m 711 klpstunnel $(sbindir)
+ 
+ $(libdir)/stunnel.so: stunnel.so
+ 	test -s stunnel.so && $(INSTALL) -m 755 stunnel.so $(libdir)
+ 
+ $(man8dir)/stunnel.8: stunnel.8
+ 	$(INSTALL) -m 644 stunnel.8 $(man8dir)
+ 
+ $(certdir)/klpstunnel.pem: klpstunnel.pem
+ 	$(INSTALL) -m 600 klpstunnel.pem $(certdir)
+ 
+ ../dist/$(VERSION).exe: stunnel.exe
+ 	./mkinstalldirs ../dist
+ 	cp -f stunnel.exe ../dist/$(VERSION).exe
+ 	gpg --yes --armor --detach-sign ../dist/$(VERSION).exe
+ 
diff -Nacr stunnel-3.8.orig/common.h stunnel-3.8/common.h
*** stunnel-3.8.orig/common.h	Thu Feb 24 06:35:00 2000
--- stunnel-3.8/common.h	Fri Jul 21 13:53:48 2000
***************
*** 18,23 ****
--- 18,26 ----
   *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   */
  
+ /* I/O buffer size */
+ #define BUFFSIZE		8192
+ 
  #define OPT_CLIENT      0x01
  #define OPT_CERT        0x02
  #define OPT_DAEMON      0x04
***************
*** 26,31 ****
--- 29,35 ----
  #define OPT_REMOTE      0x20
  #define OPT_TRANSPARENT 0x40
  #define OPT_PTY         0x80
+ #define	OPT_KHTTPS		0x100
  
  #ifdef USE_WIN32
  
***************
*** 97,105 ****
--- 101,122 ----
  #endif
  
  #include <syslog.h>
+ #include <sys/types.h>   /* u_short, u_long */
+ 
+ #ifdef HAVE_OPENSSL
+ #include <openssl/lhash.h>
+ #include <openssl/ssl.h>
+ #include <openssl/err.h>
+ #else
+ #include <lhash.h>
+ #include <ssl.h>
+ #include <err.h>
+ #endif
  
  #endif /* USE_WIN32 */
  
+ #include "nonce.h"
+ 
  #if defined(sun) && !defined(__svr4__)  /* ie. SunOS 4 */
  #define atexit(a) on_exit((a), NULL)
  extern int sys_nerr;
***************
*** 148,158 ****
      int verify_use_only_my;
      int debug_level;
      long session_timeout;
!     char *cipher_list;
      char *username;
      char *protocol;
      char *setuid_user;
      char *setgid_group;
  } server_options;
  
  /* Prototypes for stunnel.c */
--- 165,179 ----
      int verify_use_only_my;
      int debug_level;
      long session_timeout;
!     char *loc_cipher_list;
!     char *rem_cipher_list;
      char *username;
      char *protocol;
      char *setuid_user;
      char *setgid_group;
+ 	char *kssl_list;
+ 	char *https_proxy;
+ 	Cookie *cookie;
  } server_options;
  
  /* Prototypes for stunnel.c */
***************
*** 163,169 ****
  
  /* Prototypes for ssl.c */
  
- void context_init();
  void context_free();
  void client(int);
  
--- 184,189 ----
***************
*** 190,195 ****
--- 210,264 ----
  int pty_allocate(int *ptyfd, int *ttyfd, char *ttyname, int ttynamelen);
  void pty_release(char *ttyname);
  void pty_make_controlling_tty(int *ttyfd, char *ttyname);
+ 
+ 
+ /*	20000314 VRS - new kssl/https proxy modes; normal = original stunnel 
+ */
+ #define	KM_UNDEF		-1
+ #define	KM_NORMAL		0
+ #define	KM_KSSL_MITM	1
+ #define	KM_LOCAL_HTTPS	2
+ #define	KM_REMOTE_HTTPS	3
+ #define KM_FAULT		86
+ 
+ int 	check_CONNECT(const char *str, char **hp);
+ 
+ /* VRS 20000314 -- new transfer() function for kssl and https proxy
+ */
+ #define	CHAN_CLOSE	0
+ #define	CHAN_OPEN	1
+ #define	CHAN_ALT	2
+ 
+ typedef struct	Channel_	{
+ 	int 	open;
+ 	int 	bytes;
+ 	SSL_CTX	*ctx;
+ 	SSL 	*ssl;
+ 	int 	fd;
+ 	int 	ptr;
+ 	char	buff[BUFFSIZE];
+ 	}	Channel;
+ 
+ int 	rd_local (Channel *local, Channel *remote, int *km_mode);
+ int 	rd_remote(Channel *local, Channel *remote, int *km_mode);
+ int 	wr_local (Channel *local, Channel *remote, int km_mode);
+ int 	wr_remote(Channel *local, Channel *remote, int km_mode);
+ int 	got_cookie(Channel *local, Channel *remote, int km_mode);
+ int 	init_ch(Channel *channel);
+ int 	new_ssl_ch(Channel *chan, char *host);
+ int 	connect_ssl_ch(Channel *chan, char *hp);
+ int 	accept_ssl_ch(Channel *chan);
+ void	shutdown_ssl_ch(Channel *local, Channel *remote);
+ int 	wr_ssl_ch(Channel *from, Channel *to, int *numptr);
+ int 	rd_ssl_ch(Channel *chan, int *numptr);
+ int 	create_remote_sock(Channel *remote, char *hostport);
+ int 	fake_CONNECT(Channel *remote);
+ void	show_sock(int s);
+ 
+ #define	MAX_HP	256
+ 
+ void	name2nums(char *, u_long **, u_short *);
+ SSL_CTX *context_init(char *host);
  
  /* End of common.h */
  
diff -Nacr stunnel-3.8.orig/configure.in stunnel-3.8/configure.in
*** stunnel-3.8.orig/configure.in	Tue Feb 22 08:19:04 2000
--- stunnel-3.8/configure.in	Fri Jul 21 13:53:48 2000
***************
*** 42,47 ****
--- 42,56 ----
      return 1
  }
  
+ checkkrb5dir() { :
+ 	if test -f "$1/include/krb5.h"; then
+ 		AC_DEFINE(HAVE_KRB5)
+ 		krb5dir="$1"
+ 		return 0
+ 	fi
+     return 1
+ }
+ 
  dnl Check for SSL directory
  AC_MSG_CHECKING([for SSL directory])
  AC_ARG_WITH(ssl,
***************
*** 71,76 ****
--- 80,120 ----
  AC_SUBST(ssldir)
  AC_DEFINE_UNQUOTED(ssldir, "$ssldir")
  
+ dnl Check for KRB5 directory
+ AC_MSG_CHECKING([for KRB5 directory])
+ AC_ARG_WITH(krb5,
+     [  --with-krb5=DIR         location of installed KRB5 libraries/include files],
+     [
+ 		if test "$withval" != "yes"; then
+ 			dnl Check the specified localtion only
+ 			checkkrb5dir "$withval"
+ 		else
+ 			dnl Search default localtions of KRB5 library
+ 			for maindir in /usr/local /usr/lib /usr/pkg /opt; do
+ 				for dir in $maindir $maindir/krb5 ; do
+ 					checkkrb5dir $dir && break 2
+ 				done
+ 			done
+ 		fi
+     ],
+     [
+         dnl Otherwise, no KRB5 for you
+ 		AC_DEFINE(NO_KRB5)
+ 		echo
+     ]
+ )
+ if test "$krb5dir" != ""; then
+ 	AC_MSG_RESULT($krb5dir)
+     AC_SUBST(krb5dir)
+ fi
+ 
+ AC_MSG_CHECKING([whether you want to include the idea cipher])
+ AC_ARG_WITH(idea,
+ [  --without-idea          disable the idea cipher],
+ 	[use_idea=no ; CFLAGS="$CFLAGS -DNO_IDEA"],
+ 	[use_idea=yes])
+ AC_MSG_RESULT($use_idea)
+ 
  dnl Substitute host.
  AC_SUBST(host)
  AC_DEFINE_UNQUOTED(HOST, "$host")
***************
*** 94,99 ****
--- 138,150 ----
  dnl Add SSL includes and libraries
  CFLAGS="$CFLAGS -I$ssldir/include"
  LIBS="$LIBS -L$ssldir/lib -lssl -lcrypto"
+ 
+ if test "$krb5dir" != ""; then
+ dnl Add KRB5 includes and libraries
+ CFLAGS="$CFLAGS -I$krb5dir/include"
+ LIBS="$LIBS -L$krb5dir/lib -lgssapi_krb5 -lkrb5 -lcom_err"
+ LIBS="$LIBS $krb5dir/lib/libcrypto.a -lresolv"
+ fi
  
  dnl Check for RSAref library.
  AC_MSG_CHECKING([for RSAref library])
diff -Nacr stunnel-3.8.orig/ssl.c stunnel-3.8/ssl.c
*** stunnel-3.8.orig/ssl.c	Fri Feb 18 10:26:48 2000
--- stunnel-3.8/ssl.c	Fri Jul 21 13:57:59 2000
***************
*** 18,23 ****
--- 18,35 ----
   *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   */
  
+ /*	klpstunnel  stunnel-3.8, modified for use as kerberized local web proxy
+ **	20000310	VRS 	Started.  Changes to transfer() function.
+ */
+ #define	PROXY_VERSION "stunnel-3.8/kssl-0.2"
+ 
+ const char	*connect_response =
+ 		"HTTP/1.0 200 Connection established\n"
+ 		"Proxy-agent: "  PROXY_VERSION  "\n\n";
+ 
+ int 		have_cookie = 0;
+ 
+ 
  /* For US citizens having problems with patents, undefined by default */
  /* Uncomment the next line to disable RSA support */
  /* #define NO_RSA */
***************
*** 41,63 ****
  /* Max number of children */
  #define MAX_CLIENTS    100
  
- /* I/O buffer size */
- #define BUFFSIZE       8192
- 
  #include "common.h"
  
  #include <stdio.h>
  
- #ifdef HAVE_OPENSSL
- #include <openssl/lhash.h>
- #include <openssl/ssl.h>
- #include <openssl/err.h>
- #else
- #include <lhash.h>
- #include <ssl.h>
- #include <err.h>
- #endif
- 
  #ifdef USE_WIN32
  
  #define Win32_Winsock
--- 53,62 ----
***************
*** 116,134 ****
  int auth_user(struct sockaddr_in *);
  
      /* SSL functions */
- void context_init();
- void context_free();
  void client(int);
! static int transfer(SSL *, int);
  #ifndef NO_RSA
  static RSA *tmp_rsa_cb(SSL *, int, int);
  #endif /* NO_RSA */
  static int verify_callback (int, X509_STORE_CTX *);
  static void info_callback(SSL *, int, int);
! static void print_stats();
  static void print_cipher(SSL *);
  static void sslerror(char *);
  
  /* Correct callback definitions overriding ssl.h */
  #ifndef NO_RSA
  #ifdef SSL_CTX_set_tmp_rsa_callback
--- 115,133 ----
  int auth_user(struct sockaddr_in *);
  
      /* SSL functions */
  void client(int);
! static int transfer(Channel *local, Channel *remote);
  #ifndef NO_RSA
  static RSA *tmp_rsa_cb(SSL *, int, int);
  #endif /* NO_RSA */
  static int verify_callback (int, X509_STORE_CTX *);
  static void info_callback(SSL *, int, int);
! static void print_stats(SSL_CTX *ctx);
  static void print_cipher(SSL *);
  static void sslerror(char *);
  
+ void ssl3_send_alert(SSL *s,int level, int desc);
+ 
  /* Correct callback definitions overriding ssl.h */
  #ifndef NO_RSA
  #ifdef SSL_CTX_set_tmp_rsa_callback
***************
*** 138,164 ****
      SSL_CTX_ctrl(ctx,SSL_CTRL_SET_TMP_RSA_CB,0,(char *)cb)
  #endif /* NO_RSA */
  
- SSL_CTX *ctx;           /* global SSL context */
  #ifndef NO_RSA
  RSA *rsa_tmp;           /* temporary RSA key */
  #endif /* NO_RSA */
- #if SSLEAY_VERSION_NUMBER >= 0x0922
- static unsigned char *sid_ctx=(unsigned char *)"stunnel SID";
-     /* const allowed here */
- #endif
  
! void context_init() /* init SSL */
  {
  #ifndef NO_DH
      static DH *dh=NULL;
      BIO *bio=NULL;
  #endif /* NO_DH */
  
      SSLeay_add_ssl_algorithms();
      SSL_load_error_strings();
!     if(options.option&OPT_CLIENT) {
          ctx=SSL_CTX_new(SSLv3_client_method());
!     } else { /* Server mode */
          ctx=SSL_CTX_new(SSLv23_server_method());
  #ifndef NO_RSA
          log(LOG_DEBUG, "Generating %d bit temporary RSA key...", KEYLENGTH);
--- 137,168 ----
      SSL_CTX_ctrl(ctx,SSL_CTRL_SET_TMP_RSA_CB,0,(char *)cb)
  #endif /* NO_RSA */
  
  #ifndef NO_RSA
  RSA *rsa_tmp;           /* temporary RSA key */
  #endif /* NO_RSA */
  
! /*	Initialize & return SSL context.
! **	May need args if same option.options don't work for both 
! **	remote (normal) and local legs.  E.g. option.cipher_list?
! */
! SSL_CTX	*context_init(char *host)
  {
+ 	SSL_CTX *ctx;           /* (no longer) global SSL context */
  #ifndef NO_DH
      static DH *dh=NULL;
      BIO *bio=NULL;
  #endif /* NO_DH */
  
+     yaapp_RAND_load_file(NULL, NULL, 0);
      SSLeay_add_ssl_algorithms();
      SSL_load_error_strings();
!     if ((options.option & OPT_KHTTPS)  &&  host  &&  strlen(host))  {
! 		ctx=SSL_CTX_new(SSLv23_client_method());
! 		}
! 	else if ((options.option & OPT_CLIENT)  &&  host  &&  strlen(host))  {
          ctx=SSL_CTX_new(SSLv3_client_method());
! 		}
! 	else  { /* Server mode */
          ctx=SSL_CTX_new(SSLv23_server_method());
  #ifndef NO_RSA
          log(LOG_DEBUG, "Generating %d bit temporary RSA key...", KEYLENGTH);
***************
*** 170,176 ****
          if(!rsa_tmp) {
              sslerror("tmp_rsa_cb");
              exit(1);
!         }
          log(LOG_DEBUG, "Temporary RSA key generated");
          SSL_CTX_set_tmp_rsa_callback(ctx, tmp_rsa_cb);
  #endif /* NO_RSA */
--- 174,180 ----
          if(!rsa_tmp) {
              sslerror("tmp_rsa_cb");
              exit(1);
! 			}
          log(LOG_DEBUG, "Temporary RSA key generated");
          SSL_CTX_set_tmp_rsa_callback(ctx, tmp_rsa_cb);
  #endif /* NO_RSA */
***************
*** 239,268 ****
              log(LOG_NOTICE, "Peer certificate location %s", options.clientdir);
      }
      SSL_CTX_set_info_callback(ctx, info_callback);
!     if(options.cipher_list) {
!         if (!SSL_CTX_set_cipher_list(ctx, options.cipher_list)) {
              sslerror("SSL_CTX_set_cipher_list");
              exit(1);
          }
      }
- }
  
! void context_free() /* free SSL */
! {
!     SSL_CTX_free(ctx);
  }
  
  void client(int local)
  {
      struct sockaddr_in addr;
      int addrlen;
-     SSL *ssl;
      int remote;
      struct linger l;
      u_long ip;
  #ifdef USE_LIBWRAP
      struct request_info request;
  #endif
  
      log(LOG_DEBUG, "%s started", options.servname);
      l.l_onoff=1;
--- 243,273 ----
              log(LOG_NOTICE, "Peer certificate location %s", options.clientdir);
      }
      SSL_CTX_set_info_callback(ctx, info_callback);
!     if (options.loc_cipher_list  ||  options.rem_cipher_list) {
! 		char	*cipher_list = (host)?	options.rem_cipher_list:
! 										options.loc_cipher_list;
!         if (cipher_list  &&  strlen(cipher_list)  &&
! 			!SSL_CTX_set_cipher_list(ctx, cipher_list))  {
              sslerror("SSL_CTX_set_cipher_list");
              exit(1);
          }
      }
  
! 	return ctx;
  }
  
  void client(int local)
  {
      struct sockaddr_in addr;
      int addrlen;
      int remote;
      struct linger l;
      u_long ip;
  #ifdef USE_LIBWRAP
      struct request_info request;
  #endif
+     Channel	remote_ch;						/*  Normally SSL	*/
+ 	Channel	local_ch;						/*  Normally socket	*/
  
      log(LOG_DEBUG, "%s started", options.servname);
      l.l_onoff=1;
***************
*** 313,358 ****
          goto cleanup_remote;
      }
  
!     /* do the job */
!     if(!(ssl=SSL_new(ctx))) {
!         sslerror("SSL_new");
!         goto cleanup_remote;
!     }
! #if SSLEAY_VERSION_NUMBER >= 0x0922
!     SSL_set_session_id_context(ssl, sid_ctx, strlen(sid_ctx));
! #endif
!     if(options.option&OPT_CLIENT) {
!         SSL_set_fd(ssl, remote);
!         SSL_set_connect_state(ssl);
!         if(SSL_connect(ssl)<=0) {
!             sslerror("SSL_connect");
!             goto cleanup_ssl;
!         }
!         print_cipher(ssl);
!         if(transfer(ssl, local)<0)
!             goto cleanup_ssl;
!     } else {
!         SSL_set_fd(ssl, local);
!         SSL_set_accept_state(ssl);
!         if(SSL_accept(ssl)<=0) {
!             sslerror("SSL_accept");
!             goto cleanup_ssl;
!         }
!         print_cipher(ssl);
!         if(transfer(ssl, remote)<0)
!             goto cleanup_ssl;
!     }
      /* No error - normal shutdown */
!     SSL_set_shutdown(ssl, SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
!     SSL_free(ssl);
!     ERR_remove_state(0);
      closesocket(remote);
      closesocket(local);
      goto done;
  cleanup_ssl: /* close SSL and reset sockets */
!     SSL_set_shutdown(ssl, SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
!     SSL_free(ssl);
!     ERR_remove_state(0);
  cleanup_remote: /* reset remote and local socket */
      if ((options.option & OPT_REMOTE) &&
          setsockopt(remote, SOL_SOCKET, SO_LINGER, (char *)&l, sizeof(l)) < 0 &&
--- 318,347 ----
          goto cleanup_remote;
      }
  
! 	if (!init_ch(&remote_ch)  ||  !init_ch(&local_ch))  {
! 		log(LOG_ERR, "init_ch fails");
!         goto cleanup_local;
! 		}
! 	else  {
! 		/*	200000316 VRS - issues w/ session spanning multiple transfer calls.
! 		**	Orig stunnel reset here, but always to same values (fixed channels)
! 		**	Need to leave wr_remote_sock fd alone across transfers...
! 		**	How do I know when to reset it; i.e. when session ends?
! 		**	20000317 VRS - moved up from transfer() to client()
! 		*/
! 		local_ch.fd  = (options.option&OPT_CLIENT)? local: remote;
! 		remote_ch.fd = (options.option&OPT_CLIENT)? remote: local;
! 		}
! 
! 	if (transfer(&local_ch, &remote_ch) < 0)  goto cleanup_ssl;
! 
      /* No error - normal shutdown */
! 	shutdown_ssl_ch(&local_ch, &remote_ch);
      closesocket(remote);
      closesocket(local);
      goto done;
  cleanup_ssl: /* close SSL and reset sockets */
! 	shutdown_ssl_ch(&local_ch, &remote_ch);
  cleanup_remote: /* reset remote and local socket */
      if ((options.option & OPT_REMOTE) &&
          setsockopt(remote, SOL_SOCKET, SO_LINGER, (char *)&l, sizeof(l)) < 0 &&
